<?php
/*
 * Plugin Name: Kauf auf Rechnung inkl. Bonitätsprüfung
 * Description: Mit diesem Plugin, wird in WooCommerce eine weitere Zahlungsart aktiviert "Kauf auf Rechnung" zzl. bietet das Plugin eine Bonitätsprüfung.
 * Version: 1.1
 * Author: SAHU MEDIA ®
 * Author URI: https://sahu.media
 *
 * @package bonitaet-sahu
 * @copyright Copyright (c) 2020, SAHU MEDIA®
*/

/*
 * Prüfe ob WooCommerce aktiv ist.
 */
 
function sahu_karb_checkwoo_init () {
  if (class_exists( 'WooCommerce' )) {
  }else{
    add_action( 'admin_notices', 'sahu_karb_missing_wc_notice' );
  }
}
add_action( 'init', 'sahu_karb_checkwoo_init' );

// Admin Error Messages

function sahu_karb_missing_wc_notice() {
  ?>
  <div class="error notice">
      <p><?php _e( 'Du musst WooCommerce aktivieren, damit das Plugin "Kauf auf Rechnung inkl. Bonitätsprüfung" funktioniert.', 'bonitaet-sahu' ); ?></p>
  </div>
  <?php
}
 
if ( ! in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) return;

/*
 * Lade Admin-Einstellungen
 */
 
include( plugin_dir_path( __FILE__ ) . 'assets/admin.php');

/*
 * Lade WooCommerce Extra-Zahlungsarten.
 */
 
include( plugin_dir_path( __FILE__ ) . 'gateway/rechnung.php');

/*
 * Lade WooCommerce Reminder
 */
 
include( plugin_dir_path( __FILE__ ) . 'reminder/reminder.php');